clear;
clc;
warning off;

cp = 3;
cn = 5;
n = 500;

load usps_all;
x = [data(:,:,cp),data(:,:,cn)]';
x = double(x)/256;
y = [ones(1100,1);-ones(1100,1)];

candKnn = 3:8;
T = 1;

for t=1:T
    fprintf('testUSPS, %dv%d, size: %d, trail: %d...\n',cp,cn,n,t);
    rand('state',t);
    rst = randsample(size(x,1),n);
    xx = x(rst,:);
    yy = y(rst);
       
    options = [];
    options.Metric = 'Cosine';
    options.NeighborMode = 'KNN';
    options.WeightMode = 'Cosine';
    options.bSelfConnected = 1;
    
    disp('NSC...');
    ertmp = zeros(length(candKnn),1);
    for j=1:length(candKnn)
        options.k = candKnn(j);
        W = constructW(xx,options);
        L = buildNLaplacian(W);
        [dis ertmp(j)] = getClusDis(solveNSC(L),yy);
    end
    er_nsc_usps(t) = min(ertmp);
    
    disp('MVC-SL...');
    ertmp = zeros(length(candKnn),1);
    for j=1:length(candKnn)
        options.k = candKnn(j);
        W = constructW(xx,options);
        L = buildNLaplacian(W);
        Q = L+eye(n,n)/n;
        [dis ertmp(j)] = getClusDis(solveMVC_SL(1e-6,Q,1e-2,1/n),yy);
    end
    er_mvc_usps(t) = min(ertmp);
end

dispArr(er_nsc_usps)
dispArr(er_mvc_usps)
