function K = buildLSKernel(X, k)
%X: n rows of samples, d columns of features

n = size(X,1);
if nargin<2
  k = 7;
end

X2 = sum(X.^2,2);
D2 = repmat(X2',n,1)+repmat(X2,1,n)-2*X*X';
sorted = sort(D2);
kD2 = sorted(k+1,:);
sigma = sqrt(kD2);
scale = sigma'*sigma;
flag = (scale~=0);
K = zeros(n,n);
K(flag) = exp(-D2(flag)./scale(flag));
